searchData={"items":[{"type":"module","title":"NavEx","doc":"NavEx is a navigation history tool that uses adapter pattern\n  and lets you choose between available adapters or just to\n  write your own adapter.\n\n  There are 2 available adapters right now - ETS adapter storing\n  user navigation history in the ETS and Session adapter storing\n  user navigation history in user's sessions.","ref":"NavEx.html"},{"type":"module","title":"Configuration: - NavEx","doc":"config :nav_ex,\n      tracked_methods: [\"GET\"], # what methods to track\n      history_length: 10, # what is the history list length per user\n      adapter: NavEx.Adapters.ETS # adapter used by NavEx to save data","ref":"NavEx.html#module-configuration"},{"type":"module","title":"ETS Adapter config - NavEx","doc":"config NavEx.Adapters.ETS,\n      identity_key: \"nav_ex_identity\", # name of the key in cookies where the user's identity is saved\n      table_name: :navigation_history # name of the ETS table","ref":"NavEx.html#module-ets-adapter-config"},{"type":"module","title":"Session Adapter config - NavEx","doc":"config NavEx.Adapters.Session,\n      history_key: \"nav_ex_history\" # name of the key in session where navigation history is saved","ref":"NavEx.html#module-session-adapter-config"},{"type":"function","title":"NavEx.insert/1","doc":"Used by ExNav.Plug. Takes %Plug.Conn{} as an input.\n\n  Calls Adapter `insert/1` function. Always returns `{:ok, %Plug.Conn{}}` tuple.","ref":"NavEx.html#insert/1"},{"type":"function","title":"Examples - NavEx.insert/1","doc":"iex(1)> NavEx.insert(conn)\n    {:ok, %Plug.Conn{...}}","ref":"NavEx.html#insert/1-examples"},{"type":"function","title":"NavEx.last_path/1","doc":"Takes %Plug.Conn{} as an input. Calls Adapter `last_path/1` function.","ref":"NavEx.html#last_path/1"},{"type":"function","title":"Examples - NavEx.last_path/1","doc":"# for existing user\n    iex(1)> NavEx.last_path(conn)\n    {:ok, \"/sample/path\"}\n\n    # for existing user, but without 2 paths\n    iex(2)> NavEx.last_path(conn)\n    {:ok, nil}\n\n    # for not existing user\n    iex(3)> NavEx.last_path(conn)\n    {:error, :not_found}","ref":"NavEx.html#last_path/1-examples"},{"type":"function","title":"NavEx.list/1","doc":"Takes %Plug.Conn{} as an input. Calls Adapter `list/1` function.","ref":"NavEx.html#list/1"},{"type":"function","title":"Examples - NavEx.list/1","doc":"# for existing user\n    iex(1)> NavEx.list(conn)\n    {:ok, [\"/sample/path/2\", \"sample/path/1]}\n\n    # for not existing user\n    iex(2)> NavEx.list(conn)\n    {:error, :not_found}","ref":"NavEx.html#list/1-examples"},{"type":"function","title":"NavEx.path_at/2","doc":"Takes %Plug.Conn{} and number as inputs. Calls Adapter `path_at/1` function.","ref":"NavEx.html#path_at/2"},{"type":"function","title":"Examples - NavEx.path_at/2","doc":"# for existing user\n    iex(1)> NavEx.path_at(conn, 5)\n    {:ok, \"/sample/path\"}\n\n    # for existing user but exceeding paths number\n    iex(2)> NavEx.path_at(conn, 5)\n    {:ok, nil}\n\n    # for not existing user\n    iex(3)> NavEx.path_at(conn, 5)\n    {:error, :not_found}\n\n    # exceeding history limit\n    iex(4)> NavEx.path_at(conn, 999)\n    ** (ArgumentError) Max history depth is 10 counted from 0 to 9. You asked for record number 999.","ref":"NavEx.html#path_at/2-examples"},{"type":"behaviour","title":"NavEx.Adapter","doc":"Behaviour of the NavEx adapter saving the navigation history data.","ref":"NavEx.Adapter.html"},{"type":"callback","title":"NavEx.Adapter.children/0","doc":"Lists children of the adapter to be started with the application.\n  For example ETS table if your adapter needs it.","ref":"NavEx.Adapter.html#c:children/0"},{"type":"callback","title":"NavEx.Adapter.insert/1","doc":"Inserts the path into user's navigation history. Takes %Plug.Conn{} as\n  an argument, based on that fetches or creates user's identity (for\n  example as an ID in cookies) and saves his path into the storage.","ref":"NavEx.Adapter.html#c:insert/1"},{"type":"callback","title":"NavEx.Adapter.last_path/1","doc":"Returns user's last path. In case if user is not found or has no last\n  path returns error tuple.","ref":"NavEx.Adapter.html#c:last_path/1"},{"type":"callback","title":"NavEx.Adapter.list/1","doc":"Lists user navigation history. In case if user is not found returns\n  {:error, :not_found} tuple.","ref":"NavEx.Adapter.html#c:list/1"},{"type":"callback","title":"NavEx.Adapter.path_at/2","doc":"Returns user's Nth last path. In case if user is not found returns\n  an error tuple. In case if number exceeds the navigation history limit\n  returns an error tuple. In case if number exceed the user's navigation\n  history records number returns an error tuple.","ref":"NavEx.Adapter.html#c:path_at/2"},{"type":"module","title":"NavEx.Adapters.ETS","doc":"NavEx.Adapters.ETS is adapter for keeping user's navigation history\n  utilizing ETS. It uses NavEx.Adapters.ETS.RecordsStorage as the\n  module to interact with the ETS table.","ref":"NavEx.Adapters.ETS.html"},{"type":"module","title":"Adapter config - NavEx.Adapters.ETS","doc":"config NavEx.Adapters.ETS,\n      identity_key: \"nav_ex_identity\", # name of the key in cookies where the user's identity is saved\n      table_name: :navigation_history # name of the ETS table","ref":"NavEx.Adapters.ETS.html#module-adapter-config"},{"type":"module","title":"NavEx.Adapters.ETS.RecordsStorage","doc":"NavEx.Adapters.ETS.RecordsStorage is a GenServer that manages the navigation history of users using ETS (Erlang Term Storage).","ref":"NavEx.Adapters.ETS.RecordsStorage.html"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NavEx.Adapters.ETS.RecordsStorage.html#child_spec/1"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.delete_all_objects/0","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#delete_all_objects/0"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.delete_user/1","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#delete_user/1"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"NavEx.Adapters.ETS.RecordsStorage.html#init/1"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.insert/2","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#insert/2"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.last_path/1","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#last_path/1"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.list/1","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#list/1"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.path_at/2","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#path_at/2"},{"type":"function","title":"NavEx.Adapters.ETS.RecordsStorage.start_link/1","doc":"","ref":"NavEx.Adapters.ETS.RecordsStorage.html#start_link/1"},{"type":"module","title":"NavEx.Adapters.Session","doc":"NavEx.Adapters.Session is adapter for keeping user's navigation history\n  utilizing Plug.Conn session.","ref":"NavEx.Adapters.Session.html"},{"type":"module","title":"Adapter config - NavEx.Adapters.Session","doc":"config NavEx.Adapters.Session,\n      history_key: \"nav_ex_history\" # name of the key in session where navigation history is saved","ref":"NavEx.Adapters.Session.html#module-adapter-config"},{"type":"module","title":"NavEx.Plug","doc":"This is the Plug gathering data about visited paths.","ref":"NavEx.Plug.html"},{"type":"extras","title":"NavEx","doc":"# NavEx\n**Information: NavEx is currently being tested. Please notify about any bugs that might be there in Issues. Contributions welcome.**\nNavEx is the navigation history package for Elixir/Phoenix Framework. It uses adapter pattern and lets you choose between a few adapters to keep your users navigation history.","ref":"readme.html"},{"type":"extras","title":"Adapters - NavEx","doc":"","ref":"readme.html#adapters"},{"type":"extras","title":"NavEx.Adapters.ETS - NavEx","doc":"Keeps user's navigation history in the ETS. It saves user's identity in his cookies.","ref":"readme.html#navex-adapters-ets"},{"type":"extras","title":"NavEx.Adapters.Session - NavEx","doc":"Keeps user's navigation history in session. Might lead to cookies overflow error when navigation history config or links are too long.","ref":"readme.html#navex-adapters-session"},{"type":"extras","title":"Installation - NavEx","doc":"NavEx can be installed by adding `nav_ex` as a dependency in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:nav_ex, \"~> 0.1.0\"}\n  ]\nend\n```\n\nIt might be added to HexDependencies once I feel that it is ready enough for it :D","ref":"readme.html#installation"},{"type":"extras","title":"Configuration: - NavEx","doc":"","ref":"readme.html#configuration"},{"type":"extras","title":"NavEx - NavEx","doc":"```\n  config :nav_ex,\n    tracked_methods: [\"GET\"], # what methods to track\n    history_length: 10, # what is the history list length per user\n    adapter: NavEx.Adapters.ETS # adapter used by NavEx to save data\n    adapter_config: %{\n      ...\n    }\n```","ref":"readme.html#navex"},{"type":"extras","title":"Adapters - NavEx","doc":"```\n  ....\n  adapter_config: %{\n    identity_key: \"nav_ex_identity\", # name of the key in cookies where the user's identity is saved\n    table_name: :navigation_history # name of the ETS table\n  }\n```\n\n```\n  ....\n  adapter_config: %{\n    history_key: \"nav_ex_history\" # name of the key in session where navigation history is saved\n  }\n```","ref":"readme.html#adapters-1"},{"type":"extras","title":"Usage - NavEx","doc":"```\ndefmodule MyApp.Router do\n  ...\n  pipeline :browser do\n    ...\n    plug NavEx.Plug\n  end\n  ...\nend\n```\n\n**NavEx.last_path/1**\\\nIt returns 2nd last path.\n```\n# for existing user\niex(1)> NavEx.last_path(conn)\n{:ok, \"/sample/path\"}\n\n# for existing user, but without 2 paths\niex(2)> NavEx.last_path(conn)\n{:ok, nil}\n\n# for not existing user\niex(3)> NavEx.last_path(conn)\n{:error, :not_found}\n```\n\n**NavEx.path_at/2**\\\nIt returns Nth path counted from 0.\n```\n# for existing user\niex(1)> NavEx.path_at(conn, 5)\n{:ok, \"/sample/path\"}\n\n# for existing user but exceeding paths number\niex(2)> NavEx.path_at(conn, 5)\n{:ok, nil}\n\n# for not existing user\niex(3)> NavEx.path_at(conn, 5)\n{:error, :not_found}\n\niex(4)> NavEx.path_at(conn, 999)\n** (ArgumentError) Max history depth is 10 counted from 0 to 9. You asked for record number 999.\n```\n\n**NavEx.list/1**\\\nLists user's paths. Older paths have higher indexes.\n```\n# for existing user\niex(1)> NavEx.list(conn)\n{:ok, [\"/sample/path/2\", \"sample/path/1]}\n\n# for not existing user\niex(2)> NavEx.list(conn)\n{:error, :not_found}\n```","ref":"readme.html#usage"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}